//-----------------------------------------------------------------------------
// Written by Philippe.CASTAGLIOLA@univ-nantes.fr
// Universit de Nantes & IRCCyN UMR CNRS 6597
//-----------------------------------------------------------------------------
function Z=plackettburman(k,n0)
//-----------------------------------------------------------------------------
[argout,argin]=argn()
if (argin<1)|(argin>2)
  error("incorrect number of arguments")
end
if k==27
  Y1=[ 1,-1,1,1,1,1,-1,-1,-1,
       1,1,-1,1,1,1,-1,-1,-1,
      -1,1,1,1,1,1,-1,-1,-1,
      -1,-1,-1,1,-1,1,1,1,1,
      -1,-1,-1,1,1,-1,1,1,1,
      -1,-1,-1,-1,1,1,1,1,1,
       1,1,1,-1,-1,-1,1,-1,1,
       1,1,1,-1,-1,-1,1,1,-1,
       1,1,1,-1,-1,-1,-1,1,1]
  Y2=[-1,1,-1,-1,-1,1,-1,-1,1,
      -1,-1,1,1,-1,-1,1,-1,-1,
       1,-1,-1,-1,1,-1,-1,1,-1,
      -1,-1,1,-1,1,-1,-1,-1,1,
       1,-1,-1,-1,-1,1,1,-1,-1,
      -1,1,-1,1,-1,-1,-1,1,-1,
      -1,-1,1,-1,-1,1,-1,1,-1,
       1,-1,-1,1,-1,-1,-1,-1,1,
      -1,1,-1,-1,1,-1,1,-1,-1]
  Y3=[ 1,1,-1,1,-1,1,1,-1,1,
      -1,1,1,1,1,-1,1,1,-1,
       1,-1,1,-1,1,1,-1,1,1,
       1,-1,1,1,1,-1,1,-1,1,
       1,1,-1,-1,1,1,1,1,-1,
      -1,1,1,1,-1,1,-1,1,1,
       1,-1,1,1,-1,1,1,1,-1,
       1,1,-1,1,1,-1,-1,1,1,
      -1,1,1,-1,1,1,1,-1,1]
  Z=[Y1,Y2,Y3;Y2,Y3,Y1;Y3,Y1,Y2;-ones(1,27)];
else
  select k
    case 3
      Z=[1,1,-1]
    case 7
      Z=[1,1,1,-1,1,-1,-1]
    case 11
      Z=[1,1,1,-1,1,1,-1,1,-1,-1,-1]
    case 15
      Z=[1,1,1,1,-1,1,-1,1,1,-1,-1,1,-1,-1,-1]
    case 19
      Z=[1,-1,1,1,-1,-1,1,1,1,1,-1,1,-1,1,-1,-1,-1,-1,1]
    case 23
      Z=[1,1,-1,-1,-1,-1,1,-1,1,-1,-1,1,1,-1,-1,1,1,-1,1,-1,1,1,1]
    case 31
      Z=[-1,-1,-1,-1,1,-1,1,-1,1,1,1,-1,1,1,-1,-1,-1,1,1,1,1,1,-1,-1,1,1,-1,1,-1,-1,1]
    case 35
      Z=[-1,1,-1,1,1,1,-1,-1,-1,1,1,1,1,1,-1,1,1,1,-1,-1,1,-1,-1,-1,-1,1,-1,1,-1,1,1,-1,-1,1,-1]
    case 43
    Z=[1,1,-1,-1,1,-1,1,-1,-1,1,1,1,-1,1,1,1,1,1,-1,-1,-1,1,-1,1,1,1,-1,-1,-1,-1,-1,1,-1,-1,-1,1,1,-1,1,-1,1,1,-1]
    case 47
      Z=[1,1,1,1,1,-1,1,1,1,1,-1,-1,1,-1,1,-1,1,1,1,-1,-1,1,-1,-1,1,1,-1,1,1,-1,-1,-1,1,-1,1,-1,1,1,-1,-1,-1,-1,1,-1,-1,-1,-1]
    else
      error("argument ''k'' must be an integer in 3,7,...,47")
  end
  for i=2:k
    Y=Z(i-1,:)
    Z(i,:)=[Y(k),Y([1:k-1])]
  end
  Z(k+1,:)=-ones(1,k)
end
if argin==1
  n0=0
end
if (n0<0)|(n0~=floor(n0))
  error("argument ''n0'' must be an integer >= 0")
end
Z=[Z;zeros(n0,k)]
endfunction